/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gsi;

/**
 *
 * @author demel
 */
public class Stat {
    int count = 0;
    Double sum = 0.0;
    Double sum2 = 0.0;
    Double min = Double.MAX_VALUE;
    Double max = Double.MIN_VALUE;

    public void reset() {
        count = 0;
        sum = 0.0;
        sum2 = 0.0;
        min = Double.MAX_VALUE;
        max = Double.MIN_VALUE;
    }

    public void regValue(Double x) {
        count += 1;
        sum += x;
        sum2 += x*x;
        if (x < min) { min = x; }
        if (x > max) { max = x; }
    }

    public int getCount() {
        return count;
    }

    public Double getMean() {
        if (count > 0) {
            return sum / count;
        } else {
            return 0.0;
        }
    }

    public Double getStDev() {
        if (count > 1) {
            return Math.sqrt((sum2 - sum*sum/count) / (count-1));
        } else {
            return 0.0;
        }
    }

    public String strStat() {
        String s = "count = "+count+"\n";
        if (count > 0) {
            s += "mean  = "+getMean()+"\n";
        }
        if (count > 1) {
            s += "stDev = "+getStDev()+"\n"+
                 "  min = "+min+"\n"+
                 "  max = "+max+"\n";
        }
        return s;
    }

}
